/*
   -   +  Gap
iCustom(
   string symbol,       //    (NULL- )
   int timeframe,       // - (0- )
   "iEnvelopes.Gap",    //   
   //
   int ma_period,       //  MA
                           // 0 - MODE_SMA - 
                           // 1 - MODE_EMA - 
                           // 2 - MODE_SMMA - 
                           // 3 - MODE_LWMA - -
   int ma_shift,        //  MA
   int applied_price,   //  :
                           // 0 - PRICE_CLOSE -   
                           // 1 - PRICE_OPEN -  
                           // 2 - PRICE_HIGH - .
                           // 3 - PRICE_LOW - .
                           // 4 - PRICE_MEDIAN -  ,(high+low)/2
                           // 5 - PRICE_TYPICAL -  ,(high+low+close)/3
                           // 6 - PRICE_WEIGHTED -   ,(high+low+close+close)/4
                           // 7 - 
   double deviation     //      %%
   int GapPoints,       //      ; 
                           // =0-  
                           // <0-   
   //
   int mode,            // mode -   :
                           // 0- MA
                           // 1-  
                           // 2-  
   int shift            // 
   );

==============

iCustom(NULL,0,"iEnvelopes.Gap",EnvelopPeriod,Method,Shift,Price,Deviation,GapPoints, 0,i); // MA
iCustom(NULL,0,"iEnvelopes.Gap",EnvelopPeriod,Method,Shift,Price,Deviation,GapPoints, 1,i); //  
iCustom(NULL,0,"iEnvelopes.Gap",EnvelopPeriod,Method,Shift,Price,Deviation,GapPoints, 2,i); //  
*/

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LightSeaGreen 
#property indicator_style1 2
#property indicator_color2 Blue 
#property indicator_color3 Red
//  
extern int EnvelopPeriod=14; //  MA
extern int Method=0; //  MA
extern int Shift=0; // 
extern int Price=0; //  
extern double Deviation=0.1; //   MA  %%  
extern int GapPoints=0; //     .
 int GapHours=8; //      (>0)    (<0)
// .
double   MA[], // MA
         Top[], //  
         Bot[], //  
         price[], //    
         base[]; //   

void init() {
   //  
   string short_name="Env("+EnvelopPeriod+")";
   IndicatorShortName(short_name);   
   //  
   SetIndexBuffer(0,MA); // MA
   SetIndexLabel(0,short_name);
   SetIndexBuffer(1,Top); //  
   short_name=DoubleToStr(Deviation,2)+"%";
   SetIndexLabel(1,"Top+"+short_name);
   SetIndexBuffer(2,Bot); //  
   SetIndexLabel(2,"Bot-"+short_name);
   //   
   IndicatorBuffers(5);
   SetIndexBuffer(3,price); // 
   SetIndexBuffer(4,base); // 
  }

void start() {
   //  
   int limit=Bars-IndicatorCounted()-1;  
   if(limit>1) limit=Bars-1; 
   //      
   for(int i=limit; i>=0; i--) {
      price[i]=iCustom(NULL,0,"KillGap",GapPoints,GapHours,Price, 0,i); // 
      base[i] =iCustom(NULL,0,"KillGap",GapPoints,GapHours,Price, 1,i); // 
     }
   //     price[]
   for(i=limit; i>=0; i--) {
      double bs=base[i];
      MA[i] =iEnvelopesOnArray(price,Bars,EnvelopPeriod,Method,Shift,Deviation,0,i)-bs;
      Top[i]=iEnvelopesOnArray(price,Bars,EnvelopPeriod,Method,Shift,Deviation,1,i)-bs;
      Bot[i]=iEnvelopesOnArray(price,Bars,EnvelopPeriod,Method,Shift,Deviation,2,i)-bs;
     }
  }

