/*
   -   +  Sens  GapPoints
iCustom(
   string symbol,       //    (NULL- )
   int timeframe,       // - (0- )
   "StochNR.Gap",       //   
   //
   int %Kperiod,        //     
   int %Dperiod,        //    
   int slowing,         //     
   int method,          //  :
                           // 0- SMA (),
                           // 1- EMA (),
                           // 2- SSMA (),
                           // 3- LWMA (-)
   int price_field,     //    :
                           // 0- High/Low
                           // 1- Close/Close
   int GapPoints,       //   .  ; 0-  
   //
   int mode,            // mode -   :
                           // 0-  
                           // 1- 
   int shift            // 
   ) 

==============
// 
iCustom(NULL,0,"StochNR.Gap",Kperiod,Dperiod,Slowing,Dmethod,Price,Sens,GapPoints, 0,i);
// 
iCustom(NULL,0,"StochNR.Gap",Kperiod,Dperiod,Slowing,Dmethod,Price,Sens,GapPoints, 1,i);
*/

#property indicator_separate_window //  .  
#property indicator_buffers 2
#property indicator_color1 LightSeaGreen // 
#property indicator_color2 Red // 
#property indicator_style2 2
#property indicator_maximum 100
#property indicator_minimum 0
#property indicator_level1 80
#property indicator_level2 20

//  
extern int Kperiod=5; // %K
extern int Dperiod=3; // %D 
extern int Slowing=3; // 
extern int Dmethod=0; //  MA 
extern bool Price=0; // 0 -   Close, .  High/low, 1 -   Close
extern int GapPoints=0; //     .
 int GapHours=8; //      (>0)    (<0)
// .
double   Main[], // 
         Signal[], // 
         Pos[], //  
         Max[], //   
         Min[]; //   

void init() {
   //   
   IndicatorBuffers(5);
   SetIndexBuffer(0,Main); //    
   string _str="("+Kperiod+","+Slowing+")";
   SetIndexLabel(0,"Main"+_str);
   SetIndexBuffer(1,Signal); // 
   _str="("+Dperiod+")";
   SetIndexLabel(1,"Signal"+_str);
   SetIndexBuffer(2,Pos); //  
   SetIndexBuffer(3,Max); //   
   SetIndexBuffer(4,Min); //   
   //  
   _str="Stoch ";
   if(Price==0) _str=_str+"H/L";
   else _str=_str+"C/C";
   _str=_str+" ("+Kperiod+","+Dperiod+","+Slowing+")";
   IndicatorShortName(_str);   
  }

void start() {
   //  
   int limit=Bars-IndicatorCounted()-1;  
   if(limit>1) limit=Bars-1; 
   //  
   for(int i=limit; i>=0; i--) {
      double base=iCustom(NULL,0,"KillGap",GapPoints,GapHours,0,1,i); //  
      Pos[i]=Close[i]+base; //  
      //  
      if(Price) { //  Close
         Max[i]=Pos[i]; //   
         Min[i]=Pos[i]; //   
        }
      else { //  High/Low
         Max[i]=High[i]+base; //   
         Min[i]=Low[i] +base; //   
        }
     }
   //   
   for(i=limit; i>=0; i--) Main[i]=Stoch(Kperiod,Slowing,i); //  - 
   //  
   for(i=limit; i>=0; i--) Signal[i]=iMAOnArray(Main,Bars,Dperiod,0,Dmethod,i);
  }

double Stoch(int Kperiod, int Slowing, int i) {  
   if(i+Kperiod+Slowing>Bars) return(-1); //   - 
   //     /
   double max,min,c;
   for(int j=i; j<i+Slowing; j++) {
      max+=Max[ArrayMaximum(Max,Kperiod,j)]; // 
      min+=Min[ArrayMinimum(Min,Kperiod,j)]; // 
      c+=Pos[j]; //  
     }
   //  
   double delta=max-min; // 
   if(delta==0) return(50); //   
   else return(100*(c-min)/delta); // 
  }

